﻿// Fig. 13.7: SquareRootTest.cs
// Demonstrating a user-defined exception class.
using System;
using System.Windows.Forms;

namespace SquareRootTest
{
   public partial class SquareRootForm : Form
   {
      public SquareRootForm()
      {
         InitializeComponent();
      }

      // computes square root of parameter; throws 
      // NegativeNumberException if parameter is negative
      public double SquareRoot( double value )
      {
          // if negative operand, throw NegativeNumberException
          if (value < 0)
          {
              // OPTION 1: using System.Invalid
              /*
              throw new System.ArgumentException(
                            "Square root of negative number not permitted");
               

              throw new ArgumentException(
                            "Square root of negative number not permitted",
                            "value");
              */
              // OPTION2: throw user-defined NegativeNumberException
              throw new NegativeNumberException(
                            "Square root of negative number not permitted");
          }
          else
          {
              return Math.Sqrt(value); // compute square root
          }
      }

      // obtain user input, convert to double, calculate square root
      private void squareRootButton_Click( object sender, EventArgs e )
      {
         outputLabel.Text = ""; // clear OutputLabel

         // catch any NegativeNumberException thrown
         try
         {
             double result =
                SquareRoot(Convert.ToDouble(inputTextBox.Text));

             outputLabel.Text = result.ToString();
         } // end try
         catch (FormatException formatExceptionParameter)
         {
             MessageBox.Show(formatExceptionParameter.Message,
                "Invalid Number Format", MessageBoxButtons.OK,
                MessageBoxIcon.Error);
         } // end catch
         catch (ArgumentException argException)
         {
             MessageBox.Show(argException.Message,
                             "Invalid Operation", MessageBoxButtons.OK,
                             MessageBoxIcon.Error);
         }
         catch (NegativeNumberException
            negativeNumberExceptionParameter)
         {
             MessageBox.Show(negativeNumberExceptionParameter.Message,
                "Invalid Operation", MessageBoxButtons.OK,
                MessageBoxIcon.Error);
         } // end catch                                               
      } // end method squareRootButton_Click
   } // end class SquareRootForm
} // end namespace SquareRootTest
